//
//  PlateStyleKit.swift
//  HFPlate
//
//  Created by dzmitry.antonenka on 4/4/17.
//  Copyright © 2017 BSUIR. All rights reserved.
//
//  Generated by PaintCode
//  http://www.paintcodeapp.com
//



import UIKit

public class PlateStyleKit : NSObject {

    //// Drawing Methods

    @objc public dynamic class func drawGranularPlateFrontPart(plateFrame: CGRect = CGRect(x: 0, y: 0, width: 305, height: 211), edgeWidth: CGFloat = 1, topElipseEdgeWidth: CGFloat = 2, edgeColor: UIColor = UIColor(red: 1.000, green: 1.000, blue: 1.000, alpha: 1.000)) {
        //// General Declarations
        // This non-generic function dramatically improves compilation times of complex expressions.
        func fastFloor(_ x: CGFloat) -> CGFloat { return floor(x) }
        
        //// Subframes
        let plate: CGRect = CGRect(x: plateFrame.minX + fastFloor(plateFrame.width * -0.13400) + 0.5, y: plateFrame.minY + fastFloor(plateFrame.height * 0.00417) + 0.5, width: fastFloor(plateFrame.width * 1.18858 + 0.36) - fastFloor(plateFrame.width * -0.13400) - 0.36, height: fastFloor(plateFrame.height * 1.70371 + 0.05) - fastFloor(plateFrame.height * 0.00417) - 0.05)
        
        
        //// Plate
        //// Plate Main Part
        //// Plate Bottom Curve Drawing
        let plateBottomCurvePath = UIBezierPath()
        plateBottomCurvePath.move(to: CGPoint(x: plate.minX + 0.18298 * plate.width, y: plate.minY + 0.34572 * plate.height))
        plateBottomCurvePath.addCurve(to: CGPoint(x: plate.minX + 0.32588 * plate.width, y: plate.minY + 0.53367 * plate.height), controlPoint1: CGPoint(x: plate.minX + 0.21055 * plate.width, y: plate.minY + 0.50425 * plate.height), controlPoint2: CGPoint(x: plate.minX + 0.32588 * plate.width, y: plate.minY + 0.53367 * plate.height))
        plateBottomCurvePath.addCurve(to: CGPoint(x: plate.minX + 0.48633 * plate.width, y: plate.minY + 0.55162 * plate.height), controlPoint1: CGPoint(x: plate.minX + 0.32588 * plate.width, y: plate.minY + 0.53367 * plate.height), controlPoint2: CGPoint(x: plate.minX + 0.38166 * plate.width, y: plate.minY + 0.55162 * plate.height))
        plateBottomCurvePath.move(to: CGPoint(x: plate.minX + 0.78483 * plate.width, y: plate.minY + 0.34572 * plate.height))
        plateBottomCurvePath.addCurve(to: CGPoint(x: plate.minX + 0.64435 * plate.width, y: plate.minY + 0.53367 * plate.height), controlPoint1: CGPoint(x: plate.minX + 0.75725 * plate.width, y: plate.minY + 0.50425 * plate.height), controlPoint2: CGPoint(x: plate.minX + 0.64435 * plate.width, y: plate.minY + 0.53367 * plate.height))
        plateBottomCurvePath.addCurve(to: CGPoint(x: plate.minX + 0.48390 * plate.width, y: plate.minY + 0.55162 * plate.height), controlPoint1: CGPoint(x: plate.minX + 0.64435 * plate.width, y: plate.minY + 0.53367 * plate.height), controlPoint2: CGPoint(x: plate.minX + 0.58857 * plate.width, y: plate.minY + 0.55162 * plate.height))
        edgeColor.setStroke()
        plateBottomCurvePath.lineWidth = edgeWidth
        plateBottomCurvePath.stroke()
        
        
        //// Plate Top Front Ellipse Part Drawing
        let plateTopFrontEllipsePartPath = UIBezierPath()
        plateTopFrontEllipsePartPath.move(to: CGPoint(x: plate.minX + 0.78936 * plate.width, y: plate.minY + 0.34368 * plate.height))
        plateTopFrontEllipsePartPath.addCurve(to: CGPoint(x: plate.minX + 0.69714 * plate.width, y: plate.minY + 0.38334 * plate.height), controlPoint1: CGPoint(x: plate.minX + 0.78885 * plate.width, y: plate.minY + 0.36253 * plate.height), controlPoint2: CGPoint(x: plate.minX + 0.75747 * plate.width, y: plate.minY + 0.37396 * plate.height))
        plateTopFrontEllipsePartPath.addCurve(to: CGPoint(x: plate.minX + 0.48390 * plate.width, y: plate.minY + 0.39708 * plate.height), controlPoint1: CGPoint(x: plate.minX + 0.64091 * plate.width, y: plate.minY + 0.39208 * plate.height), controlPoint2: CGPoint(x: plate.minX + 0.56494 * plate.width, y: plate.minY + 0.39708 * plate.height))
        plateTopFrontEllipsePartPath.addCurve(to: CGPoint(x: plate.minX + 0.27067 * plate.width, y: plate.minY + 0.38334 * plate.height), controlPoint1: CGPoint(x: plate.minX + 0.40286 * plate.width, y: plate.minY + 0.39708 * plate.height), controlPoint2: CGPoint(x: plate.minX + 0.32690 * plate.width, y: plate.minY + 0.39208 * plate.height))
        plateTopFrontEllipsePartPath.addCurve(to: CGPoint(x: plate.minX + 0.17845 * plate.width, y: plate.minY + 0.34368 * plate.height), controlPoint1: CGPoint(x: plate.minX + 0.21034 * plate.width, y: plate.minY + 0.37396 * plate.height), controlPoint2: CGPoint(x: plate.minX + 0.17896 * plate.width, y: plate.minY + 0.36253 * plate.height))
        plateTopFrontEllipsePartPath.addLine(to: CGPoint(x: plate.minX + 0.18753 * plate.width, y: plate.minY + 0.34368 * plate.height))
        plateTopFrontEllipsePartPath.addLine(to: CGPoint(x: plate.minX + 0.18827 * plate.width, y: plate.minY + 0.34368 * plate.height))
        plateTopFrontEllipsePartPath.addCurve(to: CGPoint(x: plate.minX + 0.19107 * plate.width, y: plate.minY + 0.34626 * plate.height), controlPoint1: CGPoint(x: plate.minX + 0.18893 * plate.width, y: plate.minY + 0.34446 * plate.height), controlPoint2: CGPoint(x: plate.minX + 0.18987 * plate.width, y: plate.minY + 0.34534 * plate.height))
        plateTopFrontEllipsePartPath.addCurve(to: CGPoint(x: plate.minX + 0.20766 * plate.width, y: plate.minY + 0.35452 * plate.height), controlPoint1: CGPoint(x: plate.minX + 0.19469 * plate.width, y: plate.minY + 0.34901 * plate.height), controlPoint2: CGPoint(x: plate.minX + 0.20028 * plate.width, y: plate.minY + 0.35180 * plate.height))
        plateTopFrontEllipsePartPath.addCurve(to: CGPoint(x: plate.minX + 0.27156 * plate.width, y: plate.minY + 0.36923 * plate.height), controlPoint1: CGPoint(x: plate.minX + 0.22255 * plate.width, y: plate.minY + 0.35999 * plate.height), controlPoint2: CGPoint(x: plate.minX + 0.24432 * plate.width, y: plate.minY + 0.36500 * plate.height))
        plateTopFrontEllipsePartPath.addCurve(to: CGPoint(x: plate.minX + 0.48390 * plate.width, y: plate.minY + 0.38290 * plate.height), controlPoint1: CGPoint(x: plate.minX + 0.32747 * plate.width, y: plate.minY + 0.37793 * plate.height), controlPoint2: CGPoint(x: plate.minX + 0.40315 * plate.width, y: plate.minY + 0.38290 * plate.height))
        plateTopFrontEllipsePartPath.addCurve(to: CGPoint(x: plate.minX + 0.69624 * plate.width, y: plate.minY + 0.36923 * plate.height), controlPoint1: CGPoint(x: plate.minX + 0.56466 * plate.width, y: plate.minY + 0.38290 * plate.height), controlPoint2: CGPoint(x: plate.minX + 0.64033 * plate.width, y: plate.minY + 0.37793 * plate.height))
        plateTopFrontEllipsePartPath.addCurve(to: CGPoint(x: plate.minX + 0.76014 * plate.width, y: plate.minY + 0.35452 * plate.height), controlPoint1: CGPoint(x: plate.minX + 0.72349 * plate.width, y: plate.minY + 0.36500 * plate.height), controlPoint2: CGPoint(x: plate.minX + 0.74525 * plate.width, y: plate.minY + 0.35999 * plate.height))
        plateTopFrontEllipsePartPath.addCurve(to: CGPoint(x: plate.minX + 0.77673 * plate.width, y: plate.minY + 0.34626 * plate.height), controlPoint1: CGPoint(x: plate.minX + 0.76752 * plate.width, y: plate.minY + 0.35180 * plate.height), controlPoint2: CGPoint(x: plate.minX + 0.77311 * plate.width, y: plate.minY + 0.34901 * plate.height))
        plateTopFrontEllipsePartPath.addCurve(to: CGPoint(x: plate.minX + 0.77954 * plate.width, y: plate.minY + 0.34368 * plate.height), controlPoint1: CGPoint(x: plate.minX + 0.77794 * plate.width, y: plate.minY + 0.34534 * plate.height), controlPoint2: CGPoint(x: plate.minX + 0.77888 * plate.width, y: plate.minY + 0.34446 * plate.height))
        plateTopFrontEllipsePartPath.addLine(to: CGPoint(x: plate.minX + 0.78025 * plate.width, y: plate.minY + 0.34368 * plate.height))
        plateTopFrontEllipsePartPath.addLine(to: CGPoint(x: plate.minX + 0.78936 * plate.width, y: plate.minY + 0.34368 * plate.height))
        plateTopFrontEllipsePartPath.close()
        edgeColor.setFill()
        plateTopFrontEllipsePartPath.fill()
        
        
        //// stand bezier path Drawing
        let standBezierPathPath = UIBezierPath()
        standBezierPathPath.move(to: CGPoint(x: plate.minX + 0.33548 * plate.width, y: plate.minY + 0.53660 * plate.height))
        standBezierPathPath.addCurve(to: CGPoint(x: plate.minX + 0.35678 * plate.width, y: plate.minY + 0.56943 * plate.height), controlPoint1: CGPoint(x: plate.minX + 0.33548 * plate.width, y: plate.minY + 0.55815 * plate.height), controlPoint2: CGPoint(x: plate.minX + 0.35678 * plate.width, y: plate.minY + 0.56943 * plate.height))
        standBezierPathPath.addCurve(to: CGPoint(x: plate.minX + 0.39609 * plate.width, y: plate.minY + 0.57713 * plate.height), controlPoint1: CGPoint(x: plate.minX + 0.35678 * plate.width, y: plate.minY + 0.56943 * plate.height), controlPoint2: CGPoint(x: plate.minX + 0.36292 * plate.width, y: plate.minY + 0.57367 * plate.height))
        standBezierPathPath.addCurve(to: CGPoint(x: plate.minX + 0.48128 * plate.width, y: plate.minY + 0.58175 * plate.height), controlPoint1: CGPoint(x: plate.minX + 0.42927 * plate.width, y: plate.minY + 0.58059 * plate.height), controlPoint2: CGPoint(x: plate.minX + 0.46818 * plate.width, y: plate.minY + 0.58175 * plate.height))
        standBezierPathPath.move(to: CGPoint(x: plate.minX + 0.62872 * plate.width, y: plate.minY + 0.53544 * plate.height))
        standBezierPathPath.addCurve(to: CGPoint(x: plate.minX + 0.60579 * plate.width, y: plate.minY + 0.56943 * plate.height), controlPoint1: CGPoint(x: plate.minX + 0.62872 * plate.width, y: plate.minY + 0.55698 * plate.height), controlPoint2: CGPoint(x: plate.minX + 0.60579 * plate.width, y: plate.minY + 0.56943 * plate.height))
        standBezierPathPath.addCurve(to: CGPoint(x: plate.minX + 0.56647 * plate.width, y: plate.minY + 0.57713 * plate.height), controlPoint1: CGPoint(x: plate.minX + 0.60579 * plate.width, y: plate.minY + 0.56943 * plate.height), controlPoint2: CGPoint(x: plate.minX + 0.59964 * plate.width, y: plate.minY + 0.57367 * plate.height))
        standBezierPathPath.addCurve(to: CGPoint(x: plate.minX + 0.48128 * plate.width, y: plate.minY + 0.58175 * plate.height), controlPoint1: CGPoint(x: plate.minX + 0.53330 * plate.width, y: plate.minY + 0.58059 * plate.height), controlPoint2: CGPoint(x: plate.minX + 0.49439 * plate.width, y: plate.minY + 0.58175 * plate.height))
        edgeColor.setStroke()
        standBezierPathPath.lineWidth = edgeWidth
        standBezierPathPath.stroke()
    }
    
    @objc public dynamic class func drawGranularPlateBackPart(plateFrame: CGRect = CGRect(x: 0, y: 0, width: 250, height: 120), edgeWidth: CGFloat = 2, topElipseEdgeWidth: CGFloat = 2, edgeColor: UIColor = UIColor(red: 1.000, green: 1.000, blue: 1.000, alpha: 1.000)) {
        //// General Declarations
        // This non-generic function dramatically improves compilation times of complex expressions.
        func fastFloor(_ x: CGFloat) -> CGFloat { return floor(x) }
        
        //// Subframes
        let plate: CGRect = CGRect(x: plateFrame.minX + fastFloor(plateFrame.width * -0.00200) + 0.5, y: plateFrame.minY + fastFloor(plateFrame.height * 0.00417) + 0.5, width: fastFloor(plateFrame.width * 1.00458 + 0.36) - fastFloor(plateFrame.width * -0.00200) - 0.36, height: fastFloor(plateFrame.height * 1.70398 + 0.02) - fastFloor(plateFrame.height * 0.00417) - 0.02)
        

        //// Plate Top Back Ellipse Part Drawing
        let plateTopBackEllipsePartPath = UIBezierPath()
        plateTopBackEllipsePartPath.move(to: CGPoint(x: plate.minX + 0.90603 * plate.width, y: plate.minY + 0.34362 * plate.height))
        plateTopBackEllipsePartPath.addCurve(to: CGPoint(x: plate.minX + 0.78486 * plate.width, y: plate.minY + 0.30396 * plate.height), controlPoint1: CGPoint(x: plate.minX + 0.90536 * plate.width, y: plate.minY + 0.32477 * plate.height), controlPoint2: CGPoint(x: plate.minX + 0.86413 * plate.width, y: plate.minY + 0.31334 * plate.height))
        plateTopBackEllipsePartPath.addCurve(to: CGPoint(x: plate.minX + 0.50468 * plate.width, y: plate.minY + 0.29023 * plate.height), controlPoint1: CGPoint(x: plate.minX + 0.71097 * plate.width, y: plate.minY + 0.29522 * plate.height), controlPoint2: CGPoint(x: plate.minX + 0.61116 * plate.width, y: plate.minY + 0.29023 * plate.height))
        plateTopBackEllipsePartPath.addCurve(to: CGPoint(x: plate.minX + 0.22450 * plate.width, y: plate.minY + 0.30396 * plate.height), controlPoint1: CGPoint(x: plate.minX + 0.39820 * plate.width, y: plate.minY + 0.29023 * plate.height), controlPoint2: CGPoint(x: plate.minX + 0.29839 * plate.width, y: plate.minY + 0.29522 * plate.height))
        plateTopBackEllipsePartPath.addCurve(to: CGPoint(x: plate.minX + 0.10333 * plate.width, y: plate.minY + 0.34362 * plate.height), controlPoint1: CGPoint(x: plate.minX + 0.14523 * plate.width, y: plate.minY + 0.31334 * plate.height), controlPoint2: CGPoint(x: plate.minX + 0.10400 * plate.width, y: plate.minY + 0.32477 * plate.height))
        plateTopBackEllipsePartPath.addLine(to: CGPoint(x: plate.minX + 0.11526 * plate.width, y: plate.minY + 0.34362 * plate.height))
        plateTopBackEllipsePartPath.addLine(to: CGPoint(x: plate.minX + 0.11623 * plate.width, y: plate.minY + 0.34362 * plate.height))
        plateTopBackEllipsePartPath.addCurve(to: CGPoint(x: plate.minX + 0.11992 * plate.width, y: plate.minY + 0.34104 * plate.height), controlPoint1: CGPoint(x: plate.minX + 0.11710 * plate.width, y: plate.minY + 0.34284 * plate.height), controlPoint2: CGPoint(x: plate.minX + 0.11833 * plate.width, y: plate.minY + 0.34196 * plate.height))
        plateTopBackEllipsePartPath.addCurve(to: CGPoint(x: plate.minX + 0.14172 * plate.width, y: plate.minY + 0.33279 * plate.height), controlPoint1: CGPoint(x: plate.minX + 0.12468 * plate.width, y: plate.minY + 0.33829 * plate.height), controlPoint2: CGPoint(x: plate.minX + 0.13202 * plate.width, y: plate.minY + 0.33550 * plate.height))
        plateTopBackEllipsePartPath.addCurve(to: CGPoint(x: plate.minX + 0.22568 * plate.width, y: plate.minY + 0.31807 * plate.height), controlPoint1: CGPoint(x: plate.minX + 0.16128 * plate.width, y: plate.minY + 0.32731 * plate.height), controlPoint2: CGPoint(x: plate.minX + 0.18988 * plate.width, y: plate.minY + 0.32231 * plate.height))
        plateTopBackEllipsePartPath.addCurve(to: CGPoint(x: plate.minX + 0.50468 * plate.width, y: plate.minY + 0.30440 * plate.height), controlPoint1: CGPoint(x: plate.minX + 0.29914 * plate.width, y: plate.minY + 0.30938 * plate.height), controlPoint2: CGPoint(x: plate.minX + 0.39857 * plate.width, y: plate.minY + 0.30440 * plate.height))
        plateTopBackEllipsePartPath.addCurve(to: CGPoint(x: plate.minX + 0.78368 * plate.width, y: plate.minY + 0.31807 * plate.height), controlPoint1: CGPoint(x: plate.minX + 0.61079 * plate.width, y: plate.minY + 0.30440 * plate.height), controlPoint2: CGPoint(x: plate.minX + 0.71022 * plate.width, y: plate.minY + 0.30938 * plate.height))
        plateTopBackEllipsePartPath.addCurve(to: CGPoint(x: plate.minX + 0.86764 * plate.width, y: plate.minY + 0.33279 * plate.height), controlPoint1: CGPoint(x: plate.minX + 0.81948 * plate.width, y: plate.minY + 0.32231 * plate.height), controlPoint2: CGPoint(x: plate.minX + 0.84808 * plate.width, y: plate.minY + 0.32731 * plate.height))
        plateTopBackEllipsePartPath.addCurve(to: CGPoint(x: plate.minX + 0.88944 * plate.width, y: plate.minY + 0.34104 * plate.height), controlPoint1: CGPoint(x: plate.minX + 0.87734 * plate.width, y: plate.minY + 0.33550 * plate.height), controlPoint2: CGPoint(x: plate.minX + 0.88468 * plate.width, y: plate.minY + 0.33829 * plate.height))
        plateTopBackEllipsePartPath.addCurve(to: CGPoint(x: plate.minX + 0.89313 * plate.width, y: plate.minY + 0.34362 * plate.height), controlPoint1: CGPoint(x: plate.minX + 0.89103 * plate.width, y: plate.minY + 0.34196 * plate.height), controlPoint2: CGPoint(x: plate.minX + 0.89226 * plate.width, y: plate.minY + 0.34284 * plate.height))
        plateTopBackEllipsePartPath.addLine(to: CGPoint(x: plate.minX + 0.89405 * plate.width, y: plate.minY + 0.34362 * plate.height))
        plateTopBackEllipsePartPath.addLine(to: CGPoint(x: plate.minX + 0.90603 * plate.width, y: plate.minY + 0.34362 * plate.height))
        plateTopBackEllipsePartPath.close()
        plateTopBackEllipsePartPath.lineWidth = topElipseEdgeWidth
        edgeColor.setFill()
        plateTopBackEllipsePartPath.fill()
    }

    @objc public dynamic class func drawStarLikeGranule(frame: CGRect = CGRect(x: 0, y: 0, width: 16, height: 15),
                                          granuleBorderWidth: CGFloat = 3,
                                          granuleStrokeColor: UIColor = UIColor(red: 0.896, green: 0.750, blue: 0.031, alpha: 1.000),
                                          granuleFillColor: UIColor = UIColor(red: 0.896, green: 0.750, blue: 0.031, alpha: 1.000)
                                          )
    {
        //// Star Drawing
        let starPath = generateStarLikeGranuleBezierPath(frame: frame)
        
        granuleFillColor.setFill()
        starPath.fill()
        granuleStrokeColor.setStroke()
        starPath.lineWidth = granuleBorderWidth
        starPath.stroke()
    }

    @objc public dynamic class func drawCircleLikeGranule(frame: CGRect = CGRect(x: 0, y: 0, width: 16, height: 15),
                                          granuleBorderWidth: CGFloat = 3,
                                          granuleStrokeColor: UIColor = UIColor(red: 0.896, green: 0.750, blue: 0.031, alpha: 1.000),
                                          granuleFillColor: UIColor = UIColor(red: 0.896, green: 0.750, blue: 0.031, alpha: 1.000))
    {
        //// Star Drawing
        let starPath = generateCircleGranuleBezierPath(frame: frame, granulBorderWidth: granuleBorderWidth)

        granuleFillColor.setFill()
        starPath.fill()
        granuleStrokeColor.setStroke()
        starPath.lineWidth = granuleBorderWidth
        starPath.stroke()
    }
    
    
    @objc public dynamic class func drawFluidPlate(plateFrame: CGRect = CGRect(x: 0, y: 0, width: 250, height: 120), edgeWidth: CGFloat = 2, topEllipseEdgeWidth: CGFloat = 1, edgeColor: UIColor = UIColor(red: 1.000, green: 1.000, blue: 1.000, alpha: 1.000)) {
        //// General Declarations
        // This non-generic function dramatically improves compilation times of complex expressions.
        func fastFloor(_ x: CGFloat) -> CGFloat { return floor(x) }

        //// Subframes
        let plate: CGRect = CGRect(x: plateFrame.minX + fastFloor(plateFrame.width * 0.00800 + 0.5), y: plateFrame.minY + fastFloor(plateFrame.height * 0.18750) + 0.5, width: fastFloor(plateFrame.width * 1.00000 + 0.5) - fastFloor(plateFrame.width * 0.00800 + 0.5), height: fastFloor(plateFrame.height * 0.93333 + 0.5) - fastFloor(plateFrame.height * 0.18750) - 0.5)


        //// Plate
        //// Fill Border Drawing
        let fillBorderPath = UIBezierPath()
        fillBorderPath.move(to: CGPoint(x: plate.minX + 0.00494 * plate.width, y: plate.minY + 0.19250 * plate.height))
        fillBorderPath.addLine(to: CGPoint(x: plate.minX + 0.00304 * plate.width, y: plate.minY + 0.19585 * plate.height))
        fillBorderPath.addLine(to: CGPoint(x: plate.minX + 0.01504 * plate.width, y: plate.minY + 0.29334 * plate.height))
        fillBorderPath.addLine(to: CGPoint(x: plate.minX + 0.02704 * plate.width, y: plate.minY + 0.36790 * plate.height))
        fillBorderPath.addLine(to: CGPoint(x: plate.minX + 0.04304 * plate.width, y: plate.minY + 0.45311 * plate.height))
        fillBorderPath.addLine(to: CGPoint(x: plate.minX + 0.07104 * plate.width, y: plate.minY + 0.55142 * plate.height))
        fillBorderPath.addLine(to: CGPoint(x: plate.minX + 0.10704 * plate.width, y: plate.minY + 0.65057 * plate.height))
        fillBorderPath.addLine(to: CGPoint(x: plate.minX + 0.14304 * plate.width, y: plate.minY + 0.72348 * plate.height))
        fillBorderPath.addLine(to: CGPoint(x: plate.minX + 0.19504 * plate.width, y: plate.minY + 0.79722 * plate.height))
        fillBorderPath.addLine(to: CGPoint(x: plate.minX + 0.23904 * plate.width, y: plate.minY + 0.83607 * plate.height))
        fillBorderPath.addLine(to: CGPoint(x: plate.minX + 0.35105 * plate.width, y: plate.minY + 0.87541 * plate.height))
        fillBorderPath.addLine(to: CGPoint(x: plate.minX + 0.50305 * plate.width, y: plate.minY + 0.88853 * plate.height))
        fillBorderPath.addLine(to: CGPoint(x: plate.minX + 0.61505 * plate.width, y: plate.minY + 0.88853 * plate.height))
        fillBorderPath.addLine(to: CGPoint(x: plate.minX + 0.74305 * plate.width, y: plate.minY + 0.84638 * plate.height))
        fillBorderPath.addLine(to: CGPoint(x: plate.minX + 0.79106 * plate.width, y: plate.minY + 0.80984 * plate.height))
        fillBorderPath.addLine(to: CGPoint(x: plate.minX + 0.83779 * plate.width, y: plate.minY + 0.74724 * plate.height))
        fillBorderPath.addLine(to: CGPoint(x: plate.minX + 0.87812 * plate.width, y: plate.minY + 0.67432 * plate.height))
        fillBorderPath.addLine(to: CGPoint(x: plate.minX + 0.91038 * plate.width, y: plate.minY + 0.60058 * plate.height))
        fillBorderPath.addLine(to: CGPoint(x: plate.minX + 0.94264 * plate.width, y: plate.minY + 0.50227 * plate.height))
        fillBorderPath.addLine(to: CGPoint(x: plate.minX + 0.97087 * plate.width, y: plate.minY + 0.37937 * plate.height))
        fillBorderPath.addLine(to: CGPoint(x: plate.minX + 0.99106 * plate.width, y: plate.minY + 0.20731 * plate.height))
        fillBorderPath.addLine(to: CGPoint(x: plate.minX + 0.99011 * plate.width, y: plate.minY + 0.19250 * plate.height))

        UIColor.lightGray.setStroke()
        fillBorderPath.lineWidth = 1
        fillBorderPath.stroke()


        //// Plate Main Part
        //// Plate Bottom Curve Drawing
        let plateBottomCurvePath = UIBezierPath()
        plateBottomCurvePath.move(to: CGPoint(x: plate.minX + 0.00000 * plate.width, y: plate.minY + 0.09271 * plate.height))
        plateBottomCurvePath.addCurve(to: CGPoint(x: plate.minX + 0.23744 * plate.width, y: plate.minY + 0.84442 * plate.height), controlPoint1: CGPoint(x: plate.minX + 0.04582 * plate.width, y: plate.minY + 0.72676 * plate.height), controlPoint2: CGPoint(x: plate.minX + 0.23744 * plate.width, y: plate.minY + 0.84442 * plate.height))
        plateBottomCurvePath.addCurve(to: CGPoint(x: plate.minX + 0.50403 * plate.width, y: plate.minY + 0.91620 * plate.height), controlPoint1: CGPoint(x: plate.minX + 0.23744 * plate.width, y: plate.minY + 0.84442 * plate.height), controlPoint2: CGPoint(x: plate.minX + 0.33012 * plate.width, y: plate.minY + 0.91620 * plate.height))
        plateBottomCurvePath.move(to: CGPoint(x: plate.minX + 1.00000 * plate.width, y: plate.minY + 0.09271 * plate.height))
        plateBottomCurvePath.addCurve(to: CGPoint(x: plate.minX + 0.88354 * plate.width, y: plate.minY + 0.64789 * plate.height), controlPoint1: CGPoint(x: plate.minX + 0.98075 * plate.width, y: plate.minY + 0.35902 * plate.height), controlPoint2: CGPoint(x: plate.minX + 0.92840 * plate.width, y: plate.minY + 0.53423 * plate.height))
        plateBottomCurvePath.addCurve(to: CGPoint(x: plate.minX + 0.76660 * plate.width, y: plate.minY + 0.83316 * plate.height), controlPoint1: CGPoint(x: plate.minX + 0.82160 * plate.width, y: plate.minY + 0.80484 * plate.height), controlPoint2: CGPoint(x: plate.minX + 0.76660 * plate.width, y: plate.minY + 0.83316 * plate.height))
        plateBottomCurvePath.addCurve(to: CGPoint(x: plate.minX + 0.50000 * plate.width, y: plate.minY + 0.91620 * plate.height), controlPoint1: CGPoint(x: plate.minX + 0.76660 * plate.width, y: plate.minY + 0.83316 * plate.height), controlPoint2: CGPoint(x: plate.minX + 0.67391 * plate.width, y: plate.minY + 0.91620 * plate.height))
        edgeColor.setStroke()
        plateBottomCurvePath.lineWidth = edgeWidth
        plateBottomCurvePath.stroke()


        //// Plate Top Ellipse Drawing
        let plateTopEllipsePath = UIBezierPath(ovalIn: CGRect(x: plate.minX + fastFloor(plate.width * 0.00000 + 0.5), y: plate.minY + fastFloor(plate.height * 0.00000 + 0.5), width: fastFloor(plate.width * 1.00000 + 0.5) - fastFloor(plate.width * 0.00000 + 0.5), height: fastFloor(plate.height * 0.21564 + 0.2) - fastFloor(plate.height * 0.00000 + 0.5) + 0.3))
        edgeColor.setStroke()
        plateTopEllipsePath.lineWidth = topEllipseEdgeWidth
        plateTopEllipsePath.stroke()




        //// stand bezier path Drawing
        let standBezierPathPath = UIBezierPath()
        standBezierPathPath.move(to: CGPoint(x: plate.minX + 0.25506 * plate.width, y: plate.minY + 0.88257 * plate.height))
        standBezierPathPath.addCurve(to: CGPoint(x: plate.minX + 0.29034 * plate.width, y: plate.minY + 0.96797 * plate.height), controlPoint1: CGPoint(x: plate.minX + 0.25506 * plate.width, y: plate.minY + 0.93861 * plate.height), controlPoint2: CGPoint(x: plate.minX + 0.29034 * plate.width, y: plate.minY + 0.96797 * plate.height))
        standBezierPathPath.addCurve(to: CGPoint(x: plate.minX + 0.35548 * plate.width, y: plate.minY + 0.98799 * plate.height), controlPoint1: CGPoint(x: plate.minX + 0.29034 * plate.width, y: plate.minY + 0.96797 * plate.height), controlPoint2: CGPoint(x: plate.minX + 0.30052 * plate.width, y: plate.minY + 0.97898 * plate.height))
        standBezierPathPath.addCurve(to: CGPoint(x: plate.minX + 0.49662 * plate.width, y: plate.minY + 1.00000 * plate.height), controlPoint1: CGPoint(x: plate.minX + 0.41044 * plate.width, y: plate.minY + 0.99700 * plate.height), controlPoint2: CGPoint(x: plate.minX + 0.47491 * plate.width, y: plate.minY + 1.00000 * plate.height))
        standBezierPathPath.move(to: CGPoint(x: plate.minX + 0.74089 * plate.width, y: plate.minY + 0.87953 * plate.height))
        standBezierPathPath.addCurve(to: CGPoint(x: plate.minX + 0.70289 * plate.width, y: plate.minY + 0.96797 * plate.height), controlPoint1: CGPoint(x: plate.minX + 0.74089 * plate.width, y: plate.minY + 0.93557 * plate.height), controlPoint2: CGPoint(x: plate.minX + 0.70289 * plate.width, y: plate.minY + 0.96797 * plate.height))
        standBezierPathPath.addCurve(to: CGPoint(x: plate.minX + 0.63775 * plate.width, y: plate.minY + 0.98799 * plate.height), controlPoint1: CGPoint(x: plate.minX + 0.70289 * plate.width, y: plate.minY + 0.96797 * plate.height), controlPoint2: CGPoint(x: plate.minX + 0.69271 * plate.width, y: plate.minY + 0.97898 * plate.height))
        standBezierPathPath.addCurve(to: CGPoint(x: plate.minX + 0.49662 * plate.width, y: plate.minY + 1.00000 * plate.height), controlPoint1: CGPoint(x: plate.minX + 0.58279 * plate.width, y: plate.minY + 0.99700 * plate.height), controlPoint2: CGPoint(x: plate.minX + 0.51833 * plate.width, y: plate.minY + 1.00000 * plate.height))
        edgeColor.setStroke()
        standBezierPathPath.lineWidth = edgeWidth
        standBezierPathPath.stroke()
    }
}
